/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */

/* THIS FILE IS AUTOGENERATED! */
#ifndef __PERFBUF_BENCH_SKEL_H__
#define __PERFBUF_BENCH_SKEL_H__

#include <errno.h>
#include <stdlib.h>
#include <bpf/libbpf.h>

struct perfbuf_bench {
	struct bpf_object_skeleton *skeleton;
	struct bpf_object *obj;
	struct {
		struct bpf_map *perfbuf;
		struct bpf_map *data;
		struct bpf_map *rodata;
		struct bpf_map *bss;
	} maps;
	struct {
		struct bpf_program *bench_perfbuf;
	} progs;
	struct {
		struct bpf_link *bench_perfbuf;
	} links;
	struct perfbuf_bench__rodata {
		int batch_cnt;
	} *rodata;
	struct perfbuf_bench__data {
		long int sample_val;
	} *data;
	struct perfbuf_bench__bss {
		long int dropped;
	} *bss;
};

static void
perfbuf_bench__destroy(struct perfbuf_bench *obj)
{
	if (!obj)
		return;
	if (obj->skeleton)
		bpf_object__destroy_skeleton(obj->skeleton);
	free(obj);
}

static inline int
perfbuf_bench__create_skeleton(struct perfbuf_bench *obj);

static inline struct perfbuf_bench *
perfbuf_bench__open_opts(const struct bpf_object_open_opts *opts)
{
	struct perfbuf_bench *obj;
	int err;

	obj = (struct perfbuf_bench *)calloc(1, sizeof(*obj));
	if (!obj) {
		errno = ENOMEM;
		return NULL;
	}

	err = perfbuf_bench__create_skeleton(obj);
	err = err ?: bpf_object__open_skeleton(obj->skeleton, opts);
	if (err)
		goto err_out;

	return obj;
err_out:
	perfbuf_bench__destroy(obj);
	errno = -err;
	return NULL;
}

static inline struct perfbuf_bench *
perfbuf_bench__open(void)
{
	return perfbuf_bench__open_opts(NULL);
}

static inline int
perfbuf_bench__load(struct perfbuf_bench *obj)
{
	return bpf_object__load_skeleton(obj->skeleton);
}

static inline struct perfbuf_bench *
perfbuf_bench__open_and_load(void)
{
	struct perfbuf_bench *obj;
	int err;

	obj = perfbuf_bench__open();
	if (!obj)
		return NULL;
	err = perfbuf_bench__load(obj);
	if (err) {
		perfbuf_bench__destroy(obj);
		errno = -err;
		return NULL;
	}
	return obj;
}

static inline int
perfbuf_bench__attach(struct perfbuf_bench *obj)
{
	return bpf_object__attach_skeleton(obj->skeleton);
}

static inline void
perfbuf_bench__detach(struct perfbuf_bench *obj)
{
	return bpf_object__detach_skeleton(obj->skeleton);
}

static inline int
perfbuf_bench__create_skeleton(struct perfbuf_bench *obj)
{
	struct bpf_object_skeleton *s;

	s = (struct bpf_object_skeleton *)calloc(1, sizeof(*s));
	if (!s)
		goto err;
	obj->skeleton = s;

	s->sz = sizeof(*s);
	s->name = "perfbuf_bench";
	s->obj = &obj->obj;

	/* maps */
	s->map_cnt = 4;
	s->map_skel_sz = sizeof(*s->maps);
	s->maps = (struct bpf_map_skeleton *)calloc(s->map_cnt, s->map_skel_sz);
	if (!s->maps)
		goto err;

	s->maps[0].name = "perfbuf";
	s->maps[0].map = &obj->maps.perfbuf;

	s->maps[1].name = "perfbuf_.data";
	s->maps[1].map = &obj->maps.data;
	s->maps[1].mmaped = (void **)&obj->data;

	s->maps[2].name = "perfbuf_.rodata";
	s->maps[2].map = &obj->maps.rodata;
	s->maps[2].mmaped = (void **)&obj->rodata;

	s->maps[3].name = "perfbuf_.bss";
	s->maps[3].map = &obj->maps.bss;
	s->maps[3].mmaped = (void **)&obj->bss;

	/* programs */
	s->prog_cnt = 1;
	s->prog_skel_sz = sizeof(*s->progs);
	s->progs = (struct bpf_prog_skeleton *)calloc(s->prog_cnt, s->prog_skel_sz);
	if (!s->progs)
		goto err;

	s->progs[0].name = "bench_perfbuf";
	s->progs[0].prog = &obj->progs.bench_perfbuf;
	s->progs[0].link = &obj->links.bench_perfbuf;

	s->data_sz = 2928;
	s->data = (void *)"\
\x7f\x45\x4c\x46\x02\x01\x01\0\0\0\0\0\0\0\0\0\x01\0\xf7\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x70\x08\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\x40\0\x0c\0\
\x01\0\0\x2e\x73\x74\x72\x74\x61\x62\0\x2e\x73\x79\x6d\x74\x61\x62\0\x66\x65\
\x6e\x74\x72\x79\x2f\x5f\x5f\x78\x36\x34\x5f\x73\x79\x73\x5f\x67\x65\x74\x70\
\x67\x69\x64\0\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x72\x6f\x64\x61\x74\x61\0\x2e\
\x64\x61\x74\x61\0\x2e\x62\x73\x73\0\x2e\x6d\x61\x70\x73\0\x70\x65\x72\x66\x62\
\x75\x66\x5f\x62\x65\x6e\x63\x68\x2e\x63\0\x4c\x42\x42\x30\x5f\x35\0\x4c\x42\
\x42\x30\x5f\x32\0\x4c\x42\x42\x30\x5f\x34\0\x62\x65\x6e\x63\x68\x5f\x70\x65\
\x72\x66\x62\x75\x66\0\x62\x61\x74\x63\x68\x5f\x63\x6e\x74\0\x64\x72\x6f\x70\
\x70\x65\x64\0\x70\x65\x72\x66\x62\x75\x66\0\x73\x61\x6d\x70\x6c\x65\x5f\x76\
\x61\x6c\0\x5f\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x72\x65\x6c\x66\x65\x6e\x74\
\x72\x79\x2f\x5f\x5f\x78\x36\x34\x5f\x73\x79\x73\x5f\x67\x65\x74\x70\x67\x69\
\x64\0\x2e\x42\x54\x46\0\x2e\x42\x54\x46\x2e\x65\x78\x74\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x4b\0\0\0\x04\0\xf1\xff\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\x03\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x5b\0\0\0\0\0\x03\
\0\x60\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x62\0\0\0\0\0\x03\0\x70\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\x69\0\0\0\0\0\x03\0\x48\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x70\0\0\0\
\x12\0\x03\0\0\0\0\0\0\0\0\0\xd8\0\0\0\0\0\0\0\x7e\0\0\0\x11\0\x05\0\0\0\0\0\0\
\0\0\0\x04\0\0\0\0\0\0\0\x88\0\0\0\x11\0\x07\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\
\0\x90\0\0\0\x11\0\x08\0\0\0\0\0\0\0\0\0\x18\0\0\0\0\0\0\0\x98\0\0\0\x11\0\x06\
\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\xa3\0\0\0\x11\0\x04\0\0\0\0\0\0\0\0\0\x04\
\0\0\0\0\0\0\0\xbf\x16\0\0\0\0\0\0\x18\x07\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x61\x71\
\0\0\0\0\0\0\xc6\x01\x07\0\x01\0\0\0\xb4\x08\0\0\0\0\0\0\x18\x09\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x05\0\x05\0\0\0\0\0\x04\x08\0\0\x01\0\0\0\x61\x71\0\0\0\0\0\0\
\xce\x18\x02\0\0\0\0\0\xb4\0\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\xbf\x61\0\0\0\0\0\0\
\x18\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x18\x03\0\0\xff\xff\xff\xff\0\0\0\0\0\0\0\
\0\x18\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xb7\x05\0\0\x08\0\0\0\x85\0\0\0\x19\0\0\
\0\x15\0\xf1\xff\0\0\0\0\xb7\x01\0\0\x01\0\0\0\xdb\x19\0\0\0\0\0\0\x05\0\xee\
\xff\0\0\0\0\x47\x50\x4c\0\0\0\0\0\x2a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\
\x01\0\0\0\x07\0\0\0\x30\0\0\0\0\0\0\0\x01\0\0\0\x08\0\0\0\x78\0\0\0\0\0\0\0\
\x01\0\0\0\x09\0\0\0\x98\0\0\0\0\0\0\0\x01\0\0\0\x0a\0\0\0\x9f\xeb\x01\0\x18\0\
\0\0\0\0\0\0\xb8\x01\0\0\xb8\x01\0\0\xe2\x01\0\0\0\0\0\0\0\0\0\x02\x03\0\0\0\
\x01\0\0\0\0\0\0\x01\x04\0\0\0\x20\0\0\x01\0\0\0\0\0\0\0\x03\0\0\0\0\x02\0\0\0\
\x04\0\0\0\x04\0\0\0\x05\0\0\0\0\0\0\x01\x04\0\0\0\x20\0\0\0\0\0\0\0\x03\0\0\
\x04\x18\0\0\0\x19\0\0\0\x01\0\0\0\0\0\0\0\x1e\0\0\0\x01\0\0\0\x40\0\0\0\x29\0\
\0\0\x01\0\0\0\x80\0\0\0\x32\0\0\0\0\0\0\x0e\x05\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\
\x02\0\0\0\0\0\0\0\0\x01\0\0\x0d\x02\0\0\0\x3a\0\0\0\x07\0\0\0\x3e\0\0\0\x01\0\
\0\x0c\x08\0\0\0\x4c\0\0\0\0\0\0\x01\x01\0\0\0\x08\0\0\x01\0\0\0\0\0\0\0\x03\0\
\0\0\0\x0a\0\0\0\x04\0\0\0\x04\0\0\0\x51\0\0\0\0\0\0\x0e\x0b\0\0\0\x01\0\0\0\0\
\0\0\0\0\0\0\x0a\x0e\0\0\0\0\0\0\0\0\0\0\x09\x02\0\0\0\x5a\0\0\0\0\0\0\x0e\x0d\
\0\0\0\x01\0\0\0\x64\0\0\0\0\0\0\x01\x08\0\0\0\x40\0\0\x01\x6d\0\0\0\0\0\0\x0e\
\x10\0\0\0\x01\0\0\0\x78\0\0\0\0\0\0\x0e\x10\0\0\0\x01\0\0\0\xa8\x01\0\0\x01\0\
\0\x0f\x04\0\0\0\x0c\0\0\0\0\0\0\0\x04\0\0\0\xb0\x01\0\0\x01\0\0\x0f\x04\0\0\0\
\x0f\0\0\0\0\0\0\0\x04\0\0\0\xb8\x01\0\0\x01\0\0\x0f\x08\0\0\0\x11\0\0\0\0\0\0\
\0\x08\0\0\0\xbe\x01\0\0\x01\0\0\x0f\x08\0\0\0\x12\0\0\0\0\0\0\0\x08\0\0\0\xc3\
\x01\0\0\x01\0\0\x0f\x18\0\0\0\x06\0\0\0\0\0\0\0\x18\0\0\0\0\x69\x6e\x74\0\x5f\
\x5f\x41\x52\x52\x41\x59\x5f\x53\x49\x5a\x45\x5f\x54\x59\x50\x45\x5f\x5f\0\x74\
\x79\x70\x65\0\x76\x61\x6c\x75\x65\x5f\x73\x69\x7a\x65\0\x6b\x65\x79\x5f\x73\
\x69\x7a\x65\0\x70\x65\x72\x66\x62\x75\x66\0\x63\x74\x78\0\x62\x65\x6e\x63\x68\
\x5f\x70\x65\x72\x66\x62\x75\x66\0\x63\x68\x61\x72\0\x5f\x6c\x69\x63\x65\x6e\
\x73\x65\0\x62\x61\x74\x63\x68\x5f\x63\x6e\x74\0\x6c\x6f\x6e\x67\x20\x69\x6e\
\x74\0\x73\x61\x6d\x70\x6c\x65\x5f\x76\x61\x6c\0\x64\x72\x6f\x70\x70\x65\x64\0\
\x2f\x62\x75\x69\x6c\x64\x64\x69\x72\x2f\x62\x75\x69\x6c\x64\x2f\x42\x55\x49\
\x4c\x44\x2f\x6b\x65\x72\x6e\x65\x6c\x2d\x35\x2e\x31\x34\x2e\x30\x2d\x37\x31\
\x2e\x65\x6c\x39\x2f\x6c\x69\x6e\x75\x78\x2d\x35\x2e\x31\x34\x2e\x30\x2d\x37\
\x31\x2e\x65\x6c\x39\x2e\x61\x61\x72\x63\x68\x36\x34\x2f\x74\x6f\x6f\x6c\x73\
\x2f\x74\x65\x73\x74\x69\x6e\x67\x2f\x73\x65\x6c\x66\x74\x65\x73\x74\x73\x2f\
\x62\x70\x66\x2f\x70\x72\x6f\x67\x73\x2f\x70\x65\x72\x66\x62\x75\x66\x5f\x62\
\x65\x6e\x63\x68\x2e\x63\0\x69\x6e\x74\x20\x62\x65\x6e\x63\x68\x5f\x70\x65\x72\
\x66\x62\x75\x66\x28\x76\x6f\x69\x64\x20\x2a\x63\x74\x78\x29\0\x09\x66\x6f\x72\
\x20\x28\x69\x20\x3d\x20\x30\x3b\x20\x69\x20\x3c\x20\x62\x61\x74\x63\x68\x5f\
\x63\x6e\x74\x3b\x20\x69\x2b\x2b\x29\x20\x7b\0\x09\x72\x65\x74\x75\x72\x6e\x20\
\x30\x3b\0\x09\x09\x69\x66\x20\x28\x62\x70\x66\x5f\x70\x65\x72\x66\x5f\x65\x76\
\x65\x6e\x74\x5f\x6f\x75\x74\x70\x75\x74\x28\x63\x74\x78\x2c\x20\x26\x70\x65\
\x72\x66\x62\x75\x66\x2c\x20\x42\x50\x46\x5f\x46\x5f\x43\x55\x52\x52\x45\x4e\
\x54\x5f\x43\x50\x55\x2c\0\x09\x09\x09\x5f\x5f\x73\x79\x6e\x63\x5f\x61\x64\x64\
\x5f\x61\x6e\x64\x5f\x66\x65\x74\x63\x68\x28\x26\x64\x72\x6f\x70\x70\x65\x64\
\x2c\x20\x31\x29\x3b\0\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x72\x6f\x64\x61\x74\
\x61\0\x2e\x64\x61\x74\x61\0\x2e\x62\x73\x73\0\x2e\x6d\x61\x70\x73\0\x66\x65\
\x6e\x74\x72\x79\x2f\x5f\x5f\x78\x36\x34\x5f\x73\x79\x73\x5f\x67\x65\x74\x70\
\x67\x69\x64\0\0\0\0\0\0\0\x9f\xeb\x01\0\x20\0\0\0\0\0\0\0\x14\0\0\0\x14\0\0\0\
\xac\0\0\0\xc0\0\0\0\0\0\0\0\x08\0\0\0\xc9\x01\0\0\x01\0\0\0\0\0\0\0\x09\0\0\0\
\x10\0\0\0\xc9\x01\0\0\x0a\0\0\0\0\0\0\0\x80\0\0\0\xf9\0\0\0\0\x58\0\0\x08\0\0\
\0\x80\0\0\0\x16\x01\0\0\x12\x6c\0\0\x20\0\0\0\x80\0\0\0\x16\x01\0\0\x02\x6c\0\
\0\x48\0\0\0\x80\0\0\0\x16\x01\0\0\x1e\x6c\0\0\x50\0\0\0\x80\0\0\0\x16\x01\0\0\
\x12\x6c\0\0\x58\0\0\0\x80\0\0\0\x16\x01\0\0\x02\x6c\0\0\x60\0\0\0\x80\0\0\0\
\x39\x01\0\0\x02\x80\0\0\x70\0\0\0\x80\0\0\0\x44\x01\0\0\x07\x70\0\0\xb8\0\0\0\
\x80\0\0\0\x44\x01\0\0\x07\x70\0\0\xc0\0\0\0\x80\0\0\0\x82\x01\0\0\x04\x78\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\x03\0\0\0\x20\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\0\0\xd7\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x09\0\0\0\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\x18\x01\0\0\0\0\0\0\x20\x01\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\x08\0\0\0\0\
\0\0\0\x18\0\0\0\0\0\0\0\x11\0\0\0\x01\0\0\0\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x38\x02\0\0\0\0\0\0\xd8\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\x2a\0\0\0\x01\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x10\x03\0\0\0\
\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x32\
\0\0\0\x01\0\0\0\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x14\x03\0\0\0\0\0\0\x04\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x3a\0\0\0\x01\0\0\
\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x18\x03\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\x08\0\0\0\x03\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x80\x03\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x80\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x45\0\0\0\x01\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\x80\x03\0\0\0\0\0\0\x18\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\xac\0\0\0\x09\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x98\
\x03\0\0\0\0\0\0\x40\0\0\0\0\0\0\0\x02\0\0\0\x03\0\0\0\x08\0\0\0\0\0\0\0\x10\0\
\0\0\0\0\0\0\xc9\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xd8\x03\0\0\0\
\0\0\0\xb2\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\xce\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x90\x07\0\0\0\0\0\0\xe0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";

	return 0;
err:
	bpf_object__destroy_skeleton(s);
	return -ENOMEM;
}

#endif /* __PERFBUF_BENCH_SKEL_H__ */
