/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */

/* THIS FILE IS AUTOGENERATED! */
#ifndef __TEST_CORE_READ_MACROS_SKEL_H__
#define __TEST_CORE_READ_MACROS_SKEL_H__

#include <errno.h>
#include <stdlib.h>
#include <bpf/libbpf.h>

struct test_core_read_macros {
	struct bpf_object_skeleton *skeleton;
	struct bpf_object *obj;
	struct {
		struct bpf_map *bss;
	} maps;
	struct {
		struct bpf_program *handler;
	} progs;
	struct {
		struct bpf_link *handler;
	} links;
	struct test_core_read_macros__bss {
		struct callback_head k_probe_in;
		struct callback_head___shuffled k_core_in;
		struct callback_head *u_probe_in;
		struct callback_head___shuffled *u_core_in;
		long int k_probe_out;
		long int u_probe_out;
		long int k_core_out;
		long int u_core_out;
		int my_pid;
	} *bss;
};

static void
test_core_read_macros__destroy(struct test_core_read_macros *obj)
{
	if (!obj)
		return;
	if (obj->skeleton)
		bpf_object__destroy_skeleton(obj->skeleton);
	free(obj);
}

static inline int
test_core_read_macros__create_skeleton(struct test_core_read_macros *obj);

static inline struct test_core_read_macros *
test_core_read_macros__open_opts(const struct bpf_object_open_opts *opts)
{
	struct test_core_read_macros *obj;
	int err;

	obj = (struct test_core_read_macros *)calloc(1, sizeof(*obj));
	if (!obj) {
		errno = ENOMEM;
		return NULL;
	}

	err = test_core_read_macros__create_skeleton(obj);
	err = err ?: bpf_object__open_skeleton(obj->skeleton, opts);
	if (err)
		goto err_out;

	return obj;
err_out:
	test_core_read_macros__destroy(obj);
	errno = -err;
	return NULL;
}

static inline struct test_core_read_macros *
test_core_read_macros__open(void)
{
	return test_core_read_macros__open_opts(NULL);
}

static inline int
test_core_read_macros__load(struct test_core_read_macros *obj)
{
	return bpf_object__load_skeleton(obj->skeleton);
}

static inline struct test_core_read_macros *
test_core_read_macros__open_and_load(void)
{
	struct test_core_read_macros *obj;
	int err;

	obj = test_core_read_macros__open();
	if (!obj)
		return NULL;
	err = test_core_read_macros__load(obj);
	if (err) {
		test_core_read_macros__destroy(obj);
		errno = -err;
		return NULL;
	}
	return obj;
}

static inline int
test_core_read_macros__attach(struct test_core_read_macros *obj)
{
	return bpf_object__attach_skeleton(obj->skeleton);
}

static inline void
test_core_read_macros__detach(struct test_core_read_macros *obj)
{
	return bpf_object__detach_skeleton(obj->skeleton);
}

static inline int
test_core_read_macros__create_skeleton(struct test_core_read_macros *obj)
{
	struct bpf_object_skeleton *s;

	s = (struct bpf_object_skeleton *)calloc(1, sizeof(*s));
	if (!s)
		goto err;
	obj->skeleton = s;

	s->sz = sizeof(*s);
	s->name = "test_core_read_macros";
	s->obj = &obj->obj;

	/* maps */
	s->map_cnt = 1;
	s->map_skel_sz = sizeof(*s->maps);
	s->maps = (struct bpf_map_skeleton *)calloc(s->map_cnt, s->map_skel_sz);
	if (!s->maps)
		goto err;

	s->maps[0].name = "test_cor.bss";
	s->maps[0].map = &obj->maps.bss;
	s->maps[0].mmaped = (void **)&obj->bss;

	/* programs */
	s->prog_cnt = 1;
	s->prog_skel_sz = sizeof(*s->progs);
	s->progs = (struct bpf_prog_skeleton *)calloc(s->prog_cnt, s->prog_skel_sz);
	if (!s->progs)
		goto err;

	s->progs[0].name = "handler";
	s->progs[0].prog = &obj->progs.handler;
	s->progs[0].link = &obj->links.handler;

	s->data_sz = 4504;
	s->data = (void *)"\
\x7f\x45\x4c\x46\x02\x01\x01\0\0\0\0\0\0\0\0\0\x01\0\xf7\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x58\x0f\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\x40\0\x09\0\
\x01\0\0\x2e\x73\x74\x72\x74\x61\x62\0\x2e\x73\x79\x6d\x74\x61\x62\0\x72\x61\
\x77\x5f\x74\x72\x61\x63\x65\x70\x6f\x69\x6e\x74\x2f\x73\x79\x73\x5f\x65\x6e\
\x74\x65\x72\0\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x62\x73\x73\0\x74\x65\x73\x74\
\x5f\x63\x6f\x72\x65\x5f\x72\x65\x61\x64\x5f\x6d\x61\x63\x72\x6f\x73\x2e\x63\0\
\x4c\x42\x42\x30\x5f\x32\0\x68\x61\x6e\x64\x6c\x65\x72\0\x6d\x79\x5f\x70\x69\
\x64\0\x6b\x5f\x70\x72\x6f\x62\x65\x5f\x69\x6e\0\x6b\x5f\x63\x6f\x72\x65\x5f\
\x69\x6e\0\x6b\x5f\x70\x72\x6f\x62\x65\x5f\x6f\x75\x74\0\x6b\x5f\x63\x6f\x72\
\x65\x5f\x6f\x75\x74\0\x75\x5f\x70\x72\x6f\x62\x65\x5f\x69\x6e\0\x75\x5f\x70\
\x72\x6f\x62\x65\x5f\x6f\x75\x74\0\x75\x5f\x63\x6f\x72\x65\x5f\x69\x6e\0\x75\
\x5f\x63\x6f\x72\x65\x5f\x6f\x75\x74\0\x5f\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\
\x72\x65\x6c\x72\x61\x77\x5f\x74\x72\x61\x63\x65\x70\x6f\x69\x6e\x74\x2f\x73\
\x79\x73\x5f\x65\x6e\x74\x65\x72\0\x2e\x42\x54\x46\0\x2e\x42\x54\x46\x2e\x65\
\x78\x74\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x37\0\
\0\0\x04\0\xf1\xff\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x03\0\x03\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\x4f\0\0\0\0\0\x03\0\x60\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\x56\0\0\0\x12\0\x03\0\0\0\0\0\0\0\0\0\x70\x03\0\0\0\0\0\0\x5e\0\0\0\x11\0\
\x05\0\x50\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\x65\0\0\0\x11\0\x05\0\0\0\0\0\0\0\0\
\0\x10\0\0\0\0\0\0\0\x70\0\0\0\x11\0\x05\0\x10\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\
\x7a\0\0\0\x11\0\x05\0\x30\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\x86\0\0\0\x11\0\x05\
\0\x40\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\x91\0\0\0\x11\0\x05\0\x20\0\0\0\0\0\0\0\
\x08\0\0\0\0\0\0\0\x9c\0\0\0\x11\0\x05\0\x38\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\
\xa8\0\0\0\x11\0\x05\0\x28\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\xb2\0\0\0\x11\0\x05\
\0\x48\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\xbd\0\0\0\x11\0\x04\0\0\0\0\0\0\0\0\0\
\x04\0\0\0\0\0\0\0\x85\0\0\0\x0e\0\0\0\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x61\
\x11\0\0\0\0\0\0\x77\0\0\0\x20\0\0\0\x5e\x01\x66\0\0\0\0\0\xb7\x09\0\0\0\0\0\0\
\x18\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x7b\x33\0\0\0\0\0\0\xb7\x08\0\0\x08\0\0\0\
\x18\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x7b\x66\x08\0\0\0\0\0\x0f\x93\0\0\0\0\0\0\
\xbf\xa7\0\0\0\0\0\0\x07\x07\0\0\xf0\xff\xff\xff\xbf\x71\0\0\0\0\0\0\xb4\x02\0\
\0\x08\0\0\0\x85\0\0\0\x04\0\0\0\x79\xa3\xf0\xff\0\0\0\0\x0f\x93\0\0\0\0\0\0\
\xbf\x71\0\0\0\0\0\0\xb4\x02\0\0\x08\0\0\0\x85\0\0\0\x04\0\0\0\xb7\x01\0\0\x08\
\0\0\0\x79\xa3\xf0\xff\0\0\0\0\x0f\x13\0\0\0\0\0\0\xbf\xa1\0\0\0\0\0\0\x07\x01\
\0\0\xf8\xff\xff\xff\xb4\x02\0\0\x08\0\0\0\x85\0\0\0\x04\0\0\0\x18\x01\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\x79\xa2\xf8\xff\0\0\0\0\x7b\x21\0\0\0\0\0\0\x0f\x86\0\0\0\
\0\0\0\xbf\xa7\0\0\0\0\0\0\x07\x07\0\0\xf0\xff\xff\xff\xbf\x71\0\0\0\0\0\0\xb4\
\x02\0\0\x08\0\0\0\xbf\x63\0\0\0\0\0\0\x85\0\0\0\x71\0\0\0\x79\xa3\xf0\xff\0\0\
\0\0\x0f\x83\0\0\0\0\0\0\xbf\x71\0\0\0\0\0\0\xb4\x02\0\0\x08\0\0\0\x85\0\0\0\
\x71\0\0\0\xb7\x07\0\0\0\0\0\0\x79\xa3\xf0\xff\0\0\0\0\x0f\x73\0\0\0\0\0\0\xbf\
\xa1\0\0\0\0\0\0\x07\x01\0\0\xf8\xff\xff\xff\xb4\x02\0\0\x08\0\0\0\x85\0\0\0\
\x71\0\0\0\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x79\xa2\xf8\xff\0\0\0\0\x7b\x21\
\0\0\0\0\0\0\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x79\x13\0\0\0\0\0\0\x0f\x93\0\
\0\0\0\0\0\xbf\xa6\0\0\0\0\0\0\x07\x06\0\0\xf0\xff\xff\xff\xbf\x61\0\0\0\0\0\0\
\xb4\x02\0\0\x08\0\0\0\x85\0\0\0\x70\0\0\0\x79\xa3\xf0\xff\0\0\0\0\x0f\x93\0\0\
\0\0\0\0\xbf\x61\0\0\0\0\0\0\xb4\x02\0\0\x08\0\0\0\x85\0\0\0\x70\0\0\0\x79\xa3\
\xf0\xff\0\0\0\0\xb7\x01\0\0\x08\0\0\0\x0f\x13\0\0\0\0\0\0\xbf\xa1\0\0\0\0\0\0\
\x07\x01\0\0\xf8\xff\xff\xff\xb4\x02\0\0\x08\0\0\0\x85\0\0\0\x70\0\0\0\x18\x01\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x79\xa2\xf8\xff\0\0\0\0\x7b\x21\0\0\0\0\0\0\x18\
\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x79\x13\0\0\0\0\0\0\x0f\x83\0\0\0\0\0\0\xbf\
\xa6\0\0\0\0\0\0\x07\x06\0\0\xf0\xff\xff\xff\xbf\x61\0\0\0\0\0\0\xb4\x02\0\0\
\x08\0\0\0\x85\0\0\0\x70\0\0\0\x79\xa3\xf0\xff\0\0\0\0\x0f\x83\0\0\0\0\0\0\xbf\
\x61\0\0\0\0\0\0\xb4\x02\0\0\x08\0\0\0\x85\0\0\0\x70\0\0\0\x79\xa3\xf0\xff\0\0\
\0\0\x0f\x73\0\0\0\0\0\0\xbf\xa1\0\0\0\0\0\0\x07\x01\0\0\xf8\xff\xff\xff\xb4\
\x02\0\0\x08\0\0\0\x85\0\0\0\x70\0\0\0\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x79\
\xa2\xf8\xff\0\0\0\0\x7b\x21\0\0\0\0\0\0\xb4\0\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\
\x47\x50\x4c\0\0\0\0\0\x08\0\0\0\0\0\0\0\x01\0\0\0\x05\0\0\0\x38\0\0\0\0\0\0\0\
\x01\0\0\0\x06\0\0\0\x58\0\0\0\0\0\0\0\x01\0\0\0\x07\0\0\0\0\x01\0\0\0\0\0\0\
\x01\0\0\0\x08\0\0\0\xb8\x01\0\0\0\0\0\0\x01\0\0\0\x09\0\0\0\xd8\x01\0\0\0\0\0\
\0\x01\0\0\0\x0a\0\0\0\x80\x02\0\0\0\0\0\0\x01\0\0\0\x0b\0\0\0\xa0\x02\0\0\0\0\
\0\0\x01\0\0\0\x0c\0\0\0\x40\x03\0\0\0\0\0\0\x01\0\0\0\x0d\0\0\0\x9f\xeb\x01\0\
\x18\0\0\0\0\0\0\0\x54\x02\0\0\x54\x02\0\0\x34\x03\0\0\0\0\0\0\0\0\0\x02\0\0\0\
\0\0\0\0\0\x01\0\0\x0d\x03\0\0\0\x01\0\0\0\x01\0\0\0\x05\0\0\0\0\0\0\x01\x04\0\
\0\0\x20\0\0\x01\x09\0\0\0\x01\0\0\x0c\x02\0\0\0\x11\0\0\0\x02\0\0\x04\x10\0\0\
\0\x1f\0\0\0\x06\0\0\0\0\0\0\0\x24\0\0\0\x07\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\x02\
\x05\0\0\0\0\0\0\0\0\0\0\x02\x08\0\0\0\0\0\0\0\x01\0\0\x0d\0\0\0\0\0\0\0\0\x06\
\0\0\0\x29\0\0\0\x02\0\0\x04\x10\0\0\0\x24\0\0\0\x0a\0\0\0\0\0\0\0\x1f\0\0\0\
\x0c\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\x02\x0b\0\0\0\0\0\0\0\x01\0\0\x0d\0\0\0\0\0\
\0\0\0\x0c\0\0\0\0\0\0\0\0\0\0\x02\x09\0\0\0\x42\0\0\0\0\0\0\x01\x01\0\0\0\x08\
\0\0\x01\0\0\0\0\0\0\0\x03\0\0\0\0\x0d\0\0\0\x0f\0\0\0\x04\0\0\0\x47\0\0\0\0\0\
\0\x01\x04\0\0\0\x20\0\0\0\x5b\0\0\0\0\0\0\x0e\x0e\0\0\0\x01\0\0\0\x64\0\0\0\0\
\0\0\x0e\x05\0\0\0\x01\0\0\0\x6f\0\0\0\0\0\0\x0e\x09\0\0\0\x01\0\0\0\x79\0\0\0\
\0\0\0\x0e\x06\0\0\0\x01\0\0\0\x84\0\0\0\0\0\0\x0e\x0c\0\0\0\x01\0\0\0\x8e\0\0\
\0\0\0\0\x01\x08\0\0\0\x40\0\0\x01\x97\0\0\0\0\0\0\x0e\x15\0\0\0\x01\0\0\0\xa3\
\0\0\0\0\0\0\x0e\x15\0\0\0\x01\0\0\0\xaf\0\0\0\0\0\0\x0e\x15\0\0\0\x01\0\0\0\
\xba\0\0\0\0\0\0\x0e\x15\0\0\0\x01\0\0\0\xc5\0\0\0\0\0\0\x0e\x03\0\0\0\x01\0\0\
\0\x0e\x03\0\0\x01\0\0\x0f\x04\0\0\0\x10\0\0\0\0\0\0\0\x04\0\0\0\x16\x03\0\0\
\x09\0\0\x0f\x54\0\0\0\x11\0\0\0\0\0\0\0\x10\0\0\0\x12\0\0\0\x10\0\0\0\x10\0\0\
\0\x13\0\0\0\x20\0\0\0\x08\0\0\0\x14\0\0\0\x28\0\0\0\x08\0\0\0\x16\0\0\0\x30\0\
\0\0\x08\0\0\0\x17\0\0\0\x38\0\0\0\x08\0\0\0\x18\0\0\0\x40\0\0\0\x08\0\0\0\x19\
\0\0\0\x48\0\0\0\x08\0\0\0\x1a\0\0\0\x50\0\0\0\x04\0\0\0\0\x63\x74\x78\0\x69\
\x6e\x74\0\x68\x61\x6e\x64\x6c\x65\x72\0\x63\x61\x6c\x6c\x62\x61\x63\x6b\x5f\
\x68\x65\x61\x64\0\x6e\x65\x78\x74\0\x66\x75\x6e\x63\0\x63\x61\x6c\x6c\x62\x61\
\x63\x6b\x5f\x68\x65\x61\x64\x5f\x5f\x5f\x73\x68\x75\x66\x66\x6c\x65\x64\0\x63\
\x68\x61\x72\0\x5f\x5f\x41\x52\x52\x41\x59\x5f\x53\x49\x5a\x45\x5f\x54\x59\x50\
\x45\x5f\x5f\0\x5f\x6c\x69\x63\x65\x6e\x73\x65\0\x6b\x5f\x70\x72\x6f\x62\x65\
\x5f\x69\x6e\0\x6b\x5f\x63\x6f\x72\x65\x5f\x69\x6e\0\x75\x5f\x70\x72\x6f\x62\
\x65\x5f\x69\x6e\0\x75\x5f\x63\x6f\x72\x65\x5f\x69\x6e\0\x6c\x6f\x6e\x67\x20\
\x69\x6e\x74\0\x6b\x5f\x70\x72\x6f\x62\x65\x5f\x6f\x75\x74\0\x75\x5f\x70\x72\
\x6f\x62\x65\x5f\x6f\x75\x74\0\x6b\x5f\x63\x6f\x72\x65\x5f\x6f\x75\x74\0\x75\
\x5f\x63\x6f\x72\x65\x5f\x6f\x75\x74\0\x6d\x79\x5f\x70\x69\x64\0\x2f\x62\x75\
\x69\x6c\x64\x64\x69\x72\x2f\x62\x75\x69\x6c\x64\x2f\x42\x55\x49\x4c\x44\x2f\
\x6b\x65\x72\x6e\x65\x6c\x2d\x35\x2e\x31\x34\x2e\x30\x2d\x37\x31\x2e\x65\x6c\
\x39\x2f\x6c\x69\x6e\x75\x78\x2d\x35\x2e\x31\x34\x2e\x30\x2d\x37\x31\x2e\x65\
\x6c\x39\x2e\x61\x61\x72\x63\x68\x36\x34\x2f\x74\x6f\x6f\x6c\x73\x2f\x74\x65\
\x73\x74\x69\x6e\x67\x2f\x73\x65\x6c\x66\x74\x65\x73\x74\x73\x2f\x62\x70\x66\
\x2f\x70\x72\x6f\x67\x73\x2f\x74\x65\x73\x74\x5f\x63\x6f\x72\x65\x5f\x72\x65\
\x61\x64\x5f\x6d\x61\x63\x72\x6f\x73\x2e\x63\0\x09\x69\x6e\x74\x20\x70\x69\x64\
\x20\x3d\x20\x62\x70\x66\x5f\x67\x65\x74\x5f\x63\x75\x72\x72\x65\x6e\x74\x5f\
\x70\x69\x64\x5f\x74\x67\x69\x64\x28\x29\x20\x3e\x3e\x20\x33\x32\x3b\0\x09\x69\
\x66\x20\x28\x6d\x79\x5f\x70\x69\x64\x20\x21\x3d\x20\x70\x69\x64\x29\0\x09\x6b\
\x5f\x70\x72\x6f\x62\x65\x5f\x69\x6e\x2e\x6e\x65\x78\x74\x20\x3d\x20\x26\x6b\
\x5f\x70\x72\x6f\x62\x65\x5f\x69\x6e\x3b\0\x09\x5f\x5f\x62\x75\x69\x6c\x74\x69\
\x6e\x5f\x70\x72\x65\x73\x65\x72\x76\x65\x5f\x61\x63\x63\x65\x73\x73\x5f\x69\
\x6e\x64\x65\x78\x28\x28\x7b\x6b\x5f\x63\x6f\x72\x65\x5f\x69\x6e\x2e\x6e\x65\
\x78\x74\x20\x3d\x20\x26\x6b\x5f\x63\x6f\x72\x65\x5f\x69\x6e\x3b\x7d\x29\x29\
\x3b\0\x09\x6b\x5f\x70\x72\x6f\x62\x65\x5f\x6f\x75\x74\x20\x3d\x20\x28\x6c\x6f\
\x6e\x67\x29\x42\x50\x46\x5f\x50\x52\x4f\x42\x45\x5f\x52\x45\x41\x44\x28\x26\
\x6b\x5f\x70\x72\x6f\x62\x65\x5f\x69\x6e\x2c\x20\x6e\x65\x78\x74\x2c\x20\x6e\
\x65\x78\x74\x2c\x20\x66\x75\x6e\x63\x29\x3b\0\x09\x6b\x5f\x63\x6f\x72\x65\x5f\
\x6f\x75\x74\x20\x3d\x20\x28\x6c\x6f\x6e\x67\x29\x42\x50\x46\x5f\x43\x4f\x52\
\x45\x5f\x52\x45\x41\x44\x28\x26\x6b\x5f\x63\x6f\x72\x65\x5f\x69\x6e\x2c\x20\
\x6e\x65\x78\x74\x2c\x20\x6e\x65\x78\x74\x2c\x20\x66\x75\x6e\x63\x29\x3b\0\x09\
\x75\x5f\x70\x72\x6f\x62\x65\x5f\x6f\x75\x74\x20\x3d\x20\x28\x6c\x6f\x6e\x67\
\x29\x42\x50\x46\x5f\x50\x52\x4f\x42\x45\x5f\x52\x45\x41\x44\x5f\x55\x53\x45\
\x52\x28\x75\x5f\x70\x72\x6f\x62\x65\x5f\x69\x6e\x2c\x20\x6e\x65\x78\x74\x2c\
\x20\x6e\x65\x78\x74\x2c\x20\x66\x75\x6e\x63\x29\x3b\0\x09\x75\x5f\x63\x6f\x72\
\x65\x5f\x6f\x75\x74\x20\x3d\x20\x28\x6c\x6f\x6e\x67\x29\x42\x50\x46\x5f\x43\
\x4f\x52\x45\x5f\x52\x45\x41\x44\x5f\x55\x53\x45\x52\x28\x75\x5f\x63\x6f\x72\
\x65\x5f\x69\x6e\x2c\x20\x6e\x65\x78\x74\x2c\x20\x6e\x65\x78\x74\x2c\x20\x66\
\x75\x6e\x63\x29\x3b\0\x7d\0\x30\x3a\x30\0\x30\x3a\x31\0\x6c\x69\x63\x65\x6e\
\x73\x65\0\x2e\x62\x73\x73\0\x72\x61\x77\x5f\x74\x72\x61\x63\x65\x70\x6f\x69\
\x6e\x74\x2f\x73\x79\x73\x5f\x65\x6e\x74\x65\x72\0\x9f\xeb\x01\0\x20\0\0\0\0\0\
\0\0\x14\0\0\0\x14\0\0\0\x5c\x02\0\0\x70\x02\0\0\x7c\0\0\0\x08\0\0\0\x1b\x03\0\
\0\x01\0\0\0\0\0\0\0\x04\0\0\0\x10\0\0\0\x1b\x03\0\0\x25\0\0\0\0\0\0\0\xcc\0\0\
\0\x4d\x01\0\0\x0c\x84\0\0\x08\0\0\0\xcc\0\0\0\x7a\x01\0\0\x06\x8c\0\0\x20\0\0\
\0\xcc\0\0\0\x4d\x01\0\0\x27\x84\0\0\x28\0\0\0\xcc\0\0\0\x7a\x01\0\0\x06\x8c\0\
\0\x48\0\0\0\xcc\0\0\0\x8e\x01\0\0\x12\xa4\0\0\x68\0\0\0\xcc\0\0\0\xae\x01\0\0\
\x33\xa8\0\0\x80\0\0\0\xcc\0\0\0\x8e\x01\0\0\x12\xa4\0\0\x88\0\0\0\xcc\0\0\0\
\xf2\x01\0\0\x16\xb0\0\0\xe8\0\0\0\xcc\0\0\0\x8e\x01\0\0\x12\xa4\0\0\xf0\0\0\0\
\xcc\0\0\0\xf2\x01\0\0\x16\xb0\0\0\0\x01\0\0\xcc\0\0\0\xf2\x01\0\0\x0e\xb0\0\0\
\x10\x01\0\0\xcc\0\0\0\xf2\x01\0\0\x16\xb0\0\0\x18\x01\0\0\xcc\0\0\0\xf2\x01\0\
\0\x0e\xb0\0\0\x30\x01\0\0\xcc\0\0\0\x8e\x01\0\0\x12\xa4\0\0\x38\x01\0\0\xcc\0\
\0\0\x36\x02\0\0\x15\xb4\0\0\xa0\x01\0\0\xcc\0\0\0\x8e\x01\0\0\x12\xa4\0\0\xa8\
\x01\0\0\xcc\0\0\0\x36\x02\0\0\x15\xb4\0\0\xb8\x01\0\0\xcc\0\0\0\x36\x02\0\0\
\x0d\xb4\0\0\xc8\x01\0\0\xcc\0\0\0\x36\x02\0\0\x15\xb4\0\0\xd0\x01\0\0\xcc\0\0\
\0\x36\x02\0\0\x0d\xb4\0\0\xd8\x01\0\0\xcc\0\0\0\x77\x02\0\0\x16\xb8\0\0\0\x02\
\0\0\xcc\0\0\0\x8e\x01\0\0\x12\xa4\0\0\x08\x02\0\0\xcc\0\0\0\x77\x02\0\0\x16\
\xb8\0\0\x68\x02\0\0\xcc\0\0\0\x8e\x01\0\0\x12\xa4\0\0\x70\x02\0\0\xcc\0\0\0\
\x77\x02\0\0\x16\xb8\0\0\x80\x02\0\0\xcc\0\0\0\x77\x02\0\0\x0e\xb8\0\0\x90\x02\
\0\0\xcc\0\0\0\x77\x02\0\0\x16\xb8\0\0\x98\x02\0\0\xcc\0\0\0\x77\x02\0\0\x0e\
\xb8\0\0\xa0\x02\0\0\xcc\0\0\0\xbf\x02\0\0\x15\xbc\0\0\xc8\x02\0\0\xcc\0\0\0\
\x8e\x01\0\0\x12\xa4\0\0\xd0\x02\0\0\xcc\0\0\0\xbf\x02\0\0\x15\xbc\0\0\x28\x03\
\0\0\xcc\0\0\0\x8e\x01\0\0\x12\xa4\0\0\x30\x03\0\0\xcc\0\0\0\xbf\x02\0\0\x15\
\xbc\0\0\x40\x03\0\0\xcc\0\0\0\xbf\x02\0\0\x0d\xbc\0\0\x50\x03\0\0\xcc\0\0\0\
\xbf\x02\0\0\x15\xbc\0\0\x58\x03\0\0\xcc\0\0\0\xbf\x02\0\0\x0d\xbc\0\0\x60\x03\
\0\0\xcc\0\0\0\x04\x03\0\0\x01\xc8\0\0\x10\0\0\0\x1b\x03\0\0\x07\0\0\0\x30\0\0\
\0\x05\0\0\0\x06\x03\0\0\0\0\0\0\x48\0\0\0\x05\0\0\0\x06\x03\0\0\0\0\0\0\x50\0\
\0\0\x09\0\0\0\x0a\x03\0\0\0\0\0\0\x68\0\0\0\x09\0\0\0\x0a\x03\0\0\0\0\0\0\xc8\
\0\0\0\x05\0\0\0\x0a\x03\0\0\0\0\0\0\x80\x01\0\0\x09\0\0\0\x06\x03\0\0\0\0\0\0\
\x50\x02\0\0\x05\0\0\0\x0a\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\x03\0\0\0\x20\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x40\0\0\0\0\0\0\0\xf1\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\x09\0\0\0\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x38\x01\0\0\0\0\0\
\0\x68\x01\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\x18\0\0\0\0\0\0\0\
\x11\0\0\0\x01\0\0\0\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xa0\x02\0\0\0\0\0\0\x70\
\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x2a\0\0\0\
\x01\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x10\x06\0\0\0\0\0\0\x04\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x32\0\0\0\x08\0\0\0\x03\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x18\x06\0\0\0\0\0\0\x54\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xc6\0\0\0\x09\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x18\x06\0\0\0\0\0\0\x90\0\0\0\0\0\0\0\x02\0\0\0\x03\0\0\0\x08\0\
\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\xe3\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\xa8\x06\0\0\0\0\0\0\xa0\x05\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\xe8\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x48\x0c\0\
\0\0\0\0\0\x0c\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0";

	return 0;
err:
	bpf_object__destroy_skeleton(s);
	return -ENOMEM;
}

#endif /* __TEST_CORE_READ_MACROS_SKEL_H__ */
