/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */

/* THIS FILE IS AUTOGENERATED! */
#ifndef __TEST_SNPRINTF_SINGLE_SKEL_H__
#define __TEST_SNPRINTF_SINGLE_SKEL_H__

#include <errno.h>
#include <stdlib.h>
#include <bpf/libbpf.h>

struct test_snprintf_single {
	struct bpf_object_skeleton *skeleton;
	struct bpf_object *obj;
	struct {
		struct bpf_map *rodata;
	} maps;
	struct {
		struct bpf_program *handler;
	} progs;
	struct {
		struct bpf_link *handler;
	} links;
	struct test_snprintf_single__rodata {
		char fmt[10];
	} *rodata;
};

static void
test_snprintf_single__destroy(struct test_snprintf_single *obj)
{
	if (!obj)
		return;
	if (obj->skeleton)
		bpf_object__destroy_skeleton(obj->skeleton);
	free(obj);
}

static inline int
test_snprintf_single__create_skeleton(struct test_snprintf_single *obj);

static inline struct test_snprintf_single *
test_snprintf_single__open_opts(const struct bpf_object_open_opts *opts)
{
	struct test_snprintf_single *obj;
	int err;

	obj = (struct test_snprintf_single *)calloc(1, sizeof(*obj));
	if (!obj) {
		errno = ENOMEM;
		return NULL;
	}

	err = test_snprintf_single__create_skeleton(obj);
	err = err ?: bpf_object__open_skeleton(obj->skeleton, opts);
	if (err)
		goto err_out;

	return obj;
err_out:
	test_snprintf_single__destroy(obj);
	errno = -err;
	return NULL;
}

static inline struct test_snprintf_single *
test_snprintf_single__open(void)
{
	return test_snprintf_single__open_opts(NULL);
}

static inline int
test_snprintf_single__load(struct test_snprintf_single *obj)
{
	return bpf_object__load_skeleton(obj->skeleton);
}

static inline struct test_snprintf_single *
test_snprintf_single__open_and_load(void)
{
	struct test_snprintf_single *obj;
	int err;

	obj = test_snprintf_single__open();
	if (!obj)
		return NULL;
	err = test_snprintf_single__load(obj);
	if (err) {
		test_snprintf_single__destroy(obj);
		errno = -err;
		return NULL;
	}
	return obj;
}

static inline int
test_snprintf_single__attach(struct test_snprintf_single *obj)
{
	return bpf_object__attach_skeleton(obj->skeleton);
}

static inline void
test_snprintf_single__detach(struct test_snprintf_single *obj)
{
	return bpf_object__detach_skeleton(obj->skeleton);
}

static inline int
test_snprintf_single__create_skeleton(struct test_snprintf_single *obj)
{
	struct bpf_object_skeleton *s;

	s = (struct bpf_object_skeleton *)calloc(1, sizeof(*s));
	if (!s)
		goto err;
	obj->skeleton = s;

	s->sz = sizeof(*s);
	s->name = "test_snprintf_single";
	s->obj = &obj->obj;

	/* maps */
	s->map_cnt = 1;
	s->map_skel_sz = sizeof(*s->maps);
	s->maps = (struct bpf_map_skeleton *)calloc(s->map_cnt, s->map_skel_sz);
	if (!s->maps)
		goto err;

	s->maps[0].name = "test_snp.rodata";
	s->maps[0].map = &obj->maps.rodata;
	s->maps[0].mmaped = (void **)&obj->rodata;

	/* programs */
	s->prog_cnt = 1;
	s->prog_skel_sz = sizeof(*s->progs);
	s->progs = (struct bpf_prog_skeleton *)calloc(s->prog_cnt, s->prog_skel_sz);
	if (!s->progs)
		goto err;

	s->progs[0].name = "handler";
	s->progs[0].prog = &obj->progs.handler;
	s->progs[0].link = &obj->links.handler;

	s->data_sz = 1800;
	s->data = (void *)"\
\x7f\x45\x4c\x46\x02\x01\x01\0\0\0\0\0\0\0\0\0\x01\0\xf7\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\xc8\x04\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\x40\0\x09\0\
\x01\0\0\x2e\x73\x74\x72\x74\x61\x62\0\x2e\x73\x79\x6d\x74\x61\x62\0\x72\x61\
\x77\x5f\x74\x70\x2f\x73\x79\x73\x5f\x65\x6e\x74\x65\x72\0\x2e\x72\x6f\x64\x61\
\x74\x61\0\x6c\x69\x63\x65\x6e\x73\x65\0\x74\x65\x73\x74\x5f\x73\x6e\x70\x72\
\x69\x6e\x74\x66\x5f\x73\x69\x6e\x67\x6c\x65\x2e\x63\0\x68\x61\x6e\x64\x6c\x65\
\x72\0\x66\x6d\x74\0\x5f\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x72\x65\x6c\x72\x61\
\x77\x5f\x74\x70\x2f\x73\x79\x73\x5f\x65\x6e\x74\x65\x72\0\x2e\x42\x54\x46\0\
\x2e\x42\x54\x46\x2e\x65\x78\x74\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\x32\0\0\0\x04\0\xf1\xff\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\x03\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x49\0\0\0\x12\0\x03\0\0\0\0\0\
\0\0\0\0\x60\0\0\0\0\0\0\0\x51\0\0\0\x11\0\x04\0\0\0\0\0\0\0\0\0\x0a\0\0\0\0\0\
\0\0\x55\0\0\0\x11\0\x05\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\xb7\x01\0\0\x2a\0\
\0\0\x7b\x1a\xf8\xff\0\0\0\0\xbf\xa4\0\0\0\0\0\0\x07\x04\0\0\xf8\xff\xff\xff\
\xb7\x01\0\0\0\0\0\0\xb4\x02\0\0\0\0\0\0\x18\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\xb4\x05\0\0\x08\0\0\0\x85\0\0\0\xa5\0\0\0\xb4\0\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\x47\x50\x4c\0\0\0\x30\0\0\0\0\0\0\0\x01\0\0\0\x04\0\0\0\
\x9f\xeb\x01\0\x18\0\0\0\0\0\0\0\xf4\0\0\0\xf4\0\0\0\x4e\x01\0\0\0\0\0\0\0\0\0\
\x02\x02\0\0\0\0\0\0\0\0\0\0\x0a\0\0\0\0\0\0\0\0\x01\0\0\x0d\x04\0\0\0\x01\0\0\
\0\x01\0\0\0\x05\0\0\0\0\0\0\x01\x04\0\0\0\x20\0\0\x01\x09\0\0\0\x01\0\0\x0c\
\x03\0\0\0\0\0\0\0\0\0\0\x0a\x07\0\0\0\x11\0\0\0\0\0\0\x01\x01\0\0\0\x08\0\0\
\x01\0\0\0\0\0\0\0\x03\0\0\0\0\x06\0\0\0\x09\0\0\0\x0a\0\0\0\x16\0\0\0\0\0\0\
\x01\x04\0\0\0\x20\0\0\0\x2a\0\0\0\0\0\0\x0e\x08\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\
\x03\0\0\0\0\x07\0\0\0\x09\0\0\0\x04\0\0\0\x2e\0\0\0\0\0\0\x0e\x0b\0\0\0\x01\0\
\0\0\x2d\x01\0\0\x01\0\0\x0f\x0a\0\0\0\x0a\0\0\0\0\0\0\0\x0a\0\0\0\x35\x01\0\0\
\x01\0\0\x0f\x04\0\0\0\x0c\0\0\0\0\0\0\0\x04\0\0\0\0\x63\x74\x78\0\x69\x6e\x74\
\0\x68\x61\x6e\x64\x6c\x65\x72\0\x63\x68\x61\x72\0\x5f\x5f\x41\x52\x52\x41\x59\
\x5f\x53\x49\x5a\x45\x5f\x54\x59\x50\x45\x5f\x5f\0\x66\x6d\x74\0\x5f\x6c\x69\
\x63\x65\x6e\x73\x65\0\x2f\x62\x75\x69\x6c\x64\x64\x69\x72\x2f\x62\x75\x69\x6c\
\x64\x2f\x42\x55\x49\x4c\x44\x2f\x6b\x65\x72\x6e\x65\x6c\x2d\x35\x2e\x31\x34\
\x2e\x30\x2d\x37\x31\x2e\x65\x6c\x39\x2f\x6c\x69\x6e\x75\x78\x2d\x35\x2e\x31\
\x34\x2e\x30\x2d\x37\x31\x2e\x65\x6c\x39\x2e\x61\x61\x72\x63\x68\x36\x34\x2f\
\x74\x6f\x6f\x6c\x73\x2f\x74\x65\x73\x74\x69\x6e\x67\x2f\x73\x65\x6c\x66\x74\
\x65\x73\x74\x73\x2f\x62\x70\x66\x2f\x70\x72\x6f\x67\x73\x2f\x74\x65\x73\x74\
\x5f\x73\x6e\x70\x72\x69\x6e\x74\x66\x5f\x73\x69\x6e\x67\x6c\x65\x2e\x63\0\x69\
\x6e\x74\x20\x68\x61\x6e\x64\x6c\x65\x72\x28\x63\x6f\x6e\x73\x74\x20\x76\x6f\
\x69\x64\x20\x2a\x63\x74\x78\x29\0\x09\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x6c\
\x6f\x6e\x67\x20\x6c\x6f\x6e\x67\x20\x61\x72\x67\x20\x3d\x20\x34\x32\x3b\0\x09\
\x62\x70\x66\x5f\x73\x6e\x70\x72\x69\x6e\x74\x66\x28\x4e\x55\x4c\x4c\x2c\x20\
\x30\x2c\x20\x66\x6d\x74\x2c\x20\x26\x61\x72\x67\x2c\x20\x73\x69\x7a\x65\x6f\
\x66\x28\x61\x72\x67\x29\x29\x3b\0\x09\x72\x65\x74\x75\x72\x6e\x20\x30\x3b\0\
\x2e\x72\x6f\x64\x61\x74\x61\0\x6c\x69\x63\x65\x6e\x73\x65\0\x72\x61\x77\x5f\
\x74\x70\x2f\x73\x79\x73\x5f\x65\x6e\x74\x65\x72\0\0\0\0\0\0\0\x9f\xeb\x01\0\
\x20\0\0\0\0\0\0\0\x14\0\0\0\x14\0\0\0\x5c\0\0\0\x70\0\0\0\0\0\0\0\x08\0\0\0\
\x3d\x01\0\0\x01\0\0\0\0\0\0\0\x05\0\0\0\x10\0\0\0\x3d\x01\0\0\x05\0\0\0\0\0\0\
\0\x37\0\0\0\xb7\0\0\0\0\x2c\0\0\x08\0\0\0\x37\0\0\0\xd4\0\0\0\x15\x34\0\0\x18\
\0\0\0\x37\0\0\0\0\0\0\0\0\0\0\0\x20\0\0\0\x37\0\0\0\xf2\0\0\0\x02\x3c\0\0\x50\
\0\0\0\x37\0\0\0\x22\x01\0\0\x02\x44\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\x01\0\0\0\x03\0\0\0\x20\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\
\0\0\0\x81\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x09\
\0\0\0\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xc8\0\0\0\0\0\0\0\x90\0\0\0\0\
\0\0\0\x01\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\x18\0\0\0\0\0\0\0\x11\0\0\0\x01\0\0\
\0\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x58\x01\0\0\0\0\0\0\x60\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x22\0\0\0\x01\0\0\0\x02\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\xb8\x01\0\0\0\0\0\0\x0a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x2a\0\0\0\x01\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\xc2\x01\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\x5e\0\0\0\x09\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xc8\
\x01\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x02\0\0\0\x03\0\0\0\x08\0\0\0\0\0\0\0\x10\0\
\0\0\0\0\0\0\x73\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xd8\x01\0\0\0\
\0\0\0\x5a\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x78\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x38\x04\0\0\0\0\0\0\x90\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";

	return 0;
err:
	bpf_object__destroy_skeleton(s);
	return -ENOMEM;
}

#endif /* __TEST_SNPRINTF_SINGLE_SKEL_H__ */
