/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */
/* THIS FILE IS AUTOGENERATED! */
#ifndef __TRACE_PRINTK_SKEL_H__
#define __TRACE_PRINTK_SKEL_H__

#include <stdlib.h>
#include <bpf/bpf.h>
#include <bpf/skel_internal.h>

struct trace_printk {
	struct bpf_loader_ctx ctx;
	struct {
		struct bpf_map_desc rodata;
		struct bpf_map_desc bss;
	} maps;
	struct {
		struct bpf_prog_desc sys_enter;
	} progs;
	struct {
		int sys_enter_fd;
	} links;
	struct trace_printk__bss {
		int trace_printk_ret;
		int trace_printk_ran;
	} *bss;
	struct trace_printk__rodata {
		char fmt[20];
	} *rodata;
};

static inline int
trace_printk__sys_enter__attach(struct trace_printk *skel)
{
	int prog_fd = skel->progs.sys_enter.prog_fd;
	int fd = bpf_raw_tracepoint_open(NULL, prog_fd);

	if (fd > 0)
		skel->links.sys_enter_fd = fd;
	return fd;
}

static inline int
trace_printk__attach(struct trace_printk *skel)
{
	int ret = 0;

	ret = ret < 0 ? ret : trace_printk__sys_enter__attach(skel);
	return ret < 0 ? ret : 0;
}

static inline void
trace_printk__detach(struct trace_printk *skel)
{
	skel_closenz(skel->links.sys_enter_fd);
}
static void
trace_printk__destroy(struct trace_printk *skel)
{
	if (!skel)
		return;
	trace_printk__detach(skel);
	skel_closenz(skel->progs.sys_enter.prog_fd);
	munmap(skel->rodata, 65536);
	skel_closenz(skel->maps.rodata.map_fd);
	munmap(skel->bss, 65536);
	skel_closenz(skel->maps.bss.map_fd);
	free(skel);
}
static inline struct trace_printk *
trace_printk__open(void)
{
	struct trace_printk *skel;

	skel = calloc(sizeof(*skel), 1);
	if (!skel)
		goto cleanup;
	skel->ctx.sz = (void *)&skel->links - (void *)skel;
	skel->rodata =
		mmap(NULL, 65536, PROT_READ | PROT_WRITE,
		     MAP_SHARED | MAP_ANONYMOUS, -1, 0);
	if (skel->rodata == (void *) -1)
		goto cleanup;
	memcpy(skel->rodata, (void *)"\
\x54\x65\x73\x74\x69\x6e\x67\x2c\x74\x65\x73\x74\x69\x6e\x67\x20\x25\x64\x0a\0", 20);
	skel->maps.rodata.initial_value = (__u64)(long)skel->rodata;
	skel->bss =
		mmap(NULL, 65536, PROT_READ | PROT_WRITE,
		     MAP_SHARED | MAP_ANONYMOUS, -1, 0);
	if (skel->bss == (void *) -1)
		goto cleanup;
	memcpy(skel->bss, (void *)"\
\0\0\0\0\0\0\0\0", 8);
	skel->maps.bss.initial_value = (__u64)(long)skel->bss;
	return skel;
cleanup:
	trace_printk__destroy(skel);
	return NULL;
}

static inline int
trace_printk__load(struct trace_printk *skel)
{
	struct bpf_load_and_run_opts opts = {};
	int err;

	opts.ctx = (struct bpf_loader_ctx *)skel;
	opts.data_sz = 1275;
	opts.data = (void *)"\
\x9f\xeb\x01\0\x18\0\0\0\0\0\0\0\x2c\x01\0\0\x2c\x01\0\0\x63\x01\0\0\0\0\0\0\0\
\0\0\x02\0\0\0\0\0\0\0\0\x01\0\0\x0d\x03\0\0\0\x01\0\0\0\x01\0\0\0\x05\0\0\0\0\
\0\0\x01\x04\0\0\0\x20\0\0\x01\x09\0\0\0\x01\0\0\x0c\x02\0\0\0\x13\0\0\0\0\0\0\
\x01\x01\0\0\0\x08\0\0\x01\0\0\0\0\0\0\0\x03\0\0\0\0\x05\0\0\0\x07\0\0\0\x04\0\
\0\0\x18\0\0\0\0\0\0\x01\x04\0\0\0\x20\0\0\0\x2c\0\0\0\0\0\0\x0e\x06\0\0\0\x01\
\0\0\0\x35\0\0\0\0\0\0\x0e\x03\0\0\0\x01\0\0\0\x46\0\0\0\0\0\0\x0e\x03\0\0\0\
\x01\0\0\0\0\0\0\0\0\0\0\x0a\x05\0\0\0\0\0\0\0\0\0\0\x03\0\0\0\0\x0b\0\0\0\x07\
\0\0\0\x14\0\0\0\x57\0\0\0\0\0\0\x0e\x0c\0\0\0\x01\0\0\0\x33\x01\0\0\x01\0\0\
\x0f\x04\0\0\0\x08\0\0\0\0\0\0\0\x04\0\0\0\x3b\x01\0\0\x02\0\0\x0f\x08\0\0\0\
\x09\0\0\0\0\0\0\0\x04\0\0\0\x0a\0\0\0\x04\0\0\0\x04\0\0\0\x40\x01\0\0\x01\0\0\
\x0f\x14\0\0\0\x0d\0\0\0\0\0\0\0\x14\0\0\0\0\x63\x74\x78\0\x69\x6e\x74\0\x73\
\x79\x73\x5f\x65\x6e\x74\x65\x72\0\x63\x68\x61\x72\0\x5f\x5f\x41\x52\x52\x41\
\x59\x5f\x53\x49\x5a\x45\x5f\x54\x59\x50\x45\x5f\x5f\0\x5f\x6c\x69\x63\x65\x6e\
\x73\x65\0\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x5f\x72\x65\x74\0\
\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x5f\x72\x61\x6e\0\x66\x6d\x74\
\0\x2f\x62\x75\x69\x6c\x64\x64\x69\x72\x2f\x62\x75\x69\x6c\x64\x2f\x42\x55\x49\
\x4c\x44\x2f\x6b\x65\x72\x6e\x65\x6c\x2d\x35\x2e\x31\x34\x2e\x30\x2d\x37\x31\
\x2e\x65\x6c\x39\x2f\x6c\x69\x6e\x75\x78\x2d\x35\x2e\x31\x34\x2e\x30\x2d\x37\
\x31\x2e\x65\x6c\x39\x2e\x61\x61\x72\x63\x68\x36\x34\x2f\x74\x6f\x6f\x6c\x73\
\x2f\x74\x65\x73\x74\x69\x6e\x67\x2f\x73\x65\x6c\x66\x74\x65\x73\x74\x73\x2f\
\x62\x70\x66\x2f\x70\x72\x6f\x67\x73\x2f\x74\x72\x61\x63\x65\x5f\x70\x72\x69\
\x6e\x74\x6b\x2e\x63\0\x09\x09\x09\x09\x09\x20\x20\x20\x20\x2b\x2b\x74\x72\x61\
\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x5f\x72\x61\x6e\x29\x3b\0\x09\x74\x72\x61\
\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x5f\x72\x65\x74\x20\x3d\x20\x62\x70\x66\
\x5f\x74\x72\x61\x63\x65\x5f\x70\x72\x69\x6e\x74\x6b\x28\x66\x6d\x74\x2c\x20\
\x73\x69\x7a\x65\x6f\x66\x28\x66\x6d\x74\x29\x2c\0\x09\x72\x65\x74\x75\x72\x6e\
\x20\x30\x3b\0\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x62\x73\x73\0\x2e\x72\x6f\x64\
\x61\x74\x61\0\x66\x65\x6e\x74\x72\x79\x2f\x5f\x5f\x78\x36\x34\x5f\x73\x79\x73\
\x5f\x6e\x61\x6e\x6f\x73\x6c\x65\x65\x70\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xa7\
\x02\0\0\0\0\0\0\0\0\0\0\x02\0\0\0\x04\0\0\0\x14\0\0\0\x01\0\0\0\x80\x04\0\0\0\
\0\0\0\0\0\0\0\x74\x72\x61\x63\x65\x5f\x70\x72\x2e\x72\x6f\x64\x61\x74\x61\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x54\x65\x73\x74\x69\x6e\x67\x2c\x74\
\x65\x73\x74\x69\x6e\x67\x20\x25\x64\x0a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x02\0\0\0\x04\0\0\0\x08\0\0\0\x01\
\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\x74\x72\x61\x63\x65\x5f\x70\x72\x2e\x62\x73\
\x73\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x0f\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x47\x50\x4c\0\
\x18\x61\0\0\x01\0\0\0\0\0\0\0\x04\0\0\0\x61\x13\0\0\0\0\0\0\x04\x03\0\0\x01\0\
\0\0\x63\x31\0\0\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xb4\x02\0\0\x14\0\
\0\0\x85\0\0\0\x06\0\0\0\x18\x61\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\x63\x01\0\0\0\0\
\0\0\xb4\0\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\x5b\0\0\0\
\xd3\0\0\0\x0a\x4c\0\0\x05\0\0\0\x5b\0\0\0\xf1\0\0\0\x15\x48\0\0\x09\0\0\0\x5b\
\0\0\0\xf1\0\0\0\x13\x48\0\0\x0c\0\0\0\x5b\0\0\0\x28\x01\0\0\x02\x50\0\0\x1a\0\
\0\0\x0e\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\x73\x79\x73\x5f\x65\x6e\x74\x65\x72\0\0\0\0\0\0\0\0\0\0\0\x18\
\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\x10\0\0\0\0\0\0\0\0\0\0\0\
\x04\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x5f\x5f\x78\x36\x34\x5f\
\x73\x79\x73\x5f\x6e\x61\x6e\x6f\x73\x6c\x65\x65\x70\0";
	opts.insns_sz = 4056;
	opts.insns = (void *)"\
\xbf\x16\0\0\0\0\0\0\xbf\xa1\0\0\0\0\0\0\x07\x01\0\0\x78\xfe\xff\xff\xb7\x02\0\
\0\x88\x01\0\0\xb7\x03\0\0\0\0\0\0\x85\0\0\0\x71\0\0\0\x05\0\x28\x01\0\0\0\0\
\x61\xa1\x78\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x7c\
\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x80\xfe\0\0\0\0\
\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x84\xfe\0\0\0\0\xd5\x01\x01\
\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x88\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\
\x85\0\0\0\xa8\0\0\0\x61\xa1\x8c\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\x90\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\
\x61\xa1\x94\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x98\
\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x9c\xfe\0\0\0\0\
\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xa0\xfe\0\0\0\0\xd5\x01\x01\
\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xa4\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\
\x85\0\0\0\xa8\0\0\0\x61\xa1\xa8\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\xac\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\
\x61\xa1\xb0\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xb4\
\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xb8\xfe\0\0\0\0\
\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xbc\xfe\0\0\0\0\xd5\x01\x01\
\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xc0\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\
\x85\0\0\0\xa8\0\0\0\x61\xa1\xc4\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\xc8\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\
\x61\xa1\xcc\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xd0\
\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xd4\xfe\0\0\0\0\
\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xd8\xfe\0\0\0\0\xd5\x01\x01\
\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xdc\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\
\x85\0\0\0\xa8\0\0\0\x61\xa1\xe0\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\xe4\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\
\x61\xa1\xe8\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xec\
\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xf0\xfe\0\0\0\0\
\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xf4\xfe\0\0\0\0\xd5\x01\x01\
\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xf8\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\
\x85\0\0\0\xa8\0\0\0\x61\xa1\xfc\xfe\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\0\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\
\xa1\x04\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x08\xff\
\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x0c\xff\0\0\0\0\xd5\
\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x10\xff\0\0\0\0\xd5\x01\x01\0\0\
\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x14\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\
\0\0\xa8\0\0\0\x61\xa1\x18\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\
\0\x61\xa1\x1c\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\
\x20\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x24\xff\0\0\
\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x28\xff\0\0\0\0\xd5\x01\
\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x2c\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\
\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x30\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\x34\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\
\x61\xa1\x38\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x3c\
\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x40\xff\0\0\0\0\
\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x44\xff\0\0\0\0\xd5\x01\x01\
\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x48\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\
\x85\0\0\0\xa8\0\0\0\x61\xa1\x4c\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\x50\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\
\x61\xa1\x54\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x58\
\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x5c\xff\0\0\0\0\
\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x60\xff\0\0\0\0\xd5\x01\x01\
\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x64\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\
\x85\0\0\0\xa8\0\0\0\x61\xa1\x68\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\x6c\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\
\x61\xa1\x70\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x74\
\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x78\xff\0\0\0\0\
\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x7c\xff\0\0\0\0\xd5\x01\x01\
\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x80\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\
\x85\0\0\0\xa8\0\0\0\x61\xa1\x84\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\x88\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\
\x61\xa1\x8c\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x90\
\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x94\xff\0\0\0\0\
\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x98\xff\0\0\0\0\xd5\x01\x01\
\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\x9c\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\
\x85\0\0\0\xa8\0\0\0\x61\xa1\xa0\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\xa4\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\
\x61\xa1\xa8\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xac\
\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xb0\xff\0\0\0\0\
\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xb4\xff\0\0\0\0\xd5\x01\x01\
\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xb8\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\
\x85\0\0\0\xa8\0\0\0\x61\xa1\xbc\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\xc0\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\
\x61\xa1\xc4\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xc8\
\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xcc\xff\0\0\0\0\
\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xd0\xff\0\0\0\0\xd5\x01\x01\
\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xd4\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\
\x85\0\0\0\xa8\0\0\0\x61\xa1\xd8\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\xdc\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\
\x61\xa1\xe0\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xe4\
\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xe8\xff\0\0\0\0\
\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xec\xff\0\0\0\0\xd5\x01\x01\
\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa1\xf0\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\
\x85\0\0\0\xa8\0\0\0\x61\xa1\xf4\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\x61\xa1\xf8\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\
\x61\xa1\xfc\xff\0\0\0\0\xd5\x01\x01\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\xbf\x70\0\0\
\0\0\0\0\x95\0\0\0\0\0\0\0\x61\x60\x08\0\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\
\xbf\x02\0\0\x63\x01\0\0\0\0\0\0\x61\x60\x0c\0\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\
\0\0\xbb\x02\0\0\x63\x01\0\0\0\0\0\0\x79\x60\x10\0\0\0\0\0\x18\x61\0\0\0\0\0\0\
\0\0\0\0\xaf\x02\0\0\x7b\x01\0\0\0\0\0\0\x18\x60\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x18\x61\0\0\0\0\0\0\0\0\0\0\xa7\x02\0\0\x7b\x01\0\0\0\0\0\0\xb7\x01\0\0\x12\0\
\0\0\x18\x62\0\0\0\0\0\0\0\0\0\0\xa7\x02\0\0\xb7\x03\0\0\x1c\0\0\0\x85\0\0\0\
\xa6\0\0\0\xbf\x07\0\0\0\0\0\0\xc5\x07\xc0\xfe\0\0\0\0\x63\x7a\x78\xfe\0\0\0\0\
\x61\xa0\x78\xfe\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\xf3\x02\0\0\x63\x01\0\0\0\
\0\0\0\x61\x60\x20\0\0\0\0\0\x15\0\x03\0\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\
\xcf\x02\0\0\x63\x01\0\0\0\0\0\0\xb7\x01\0\0\0\0\0\0\x18\x62\0\0\0\0\0\0\0\0\0\
\0\xc3\x02\0\0\xb7\x03\0\0\x40\0\0\0\x85\0\0\0\xa6\0\0\0\xbf\x07\0\0\0\0\0\0\
\xc5\x07\xaf\xfe\0\0\0\0\x63\x7a\x7c\xfe\0\0\0\0\x79\x63\x18\0\0\0\0\0\x15\x03\
\x04\0\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x03\x03\0\0\xb7\x02\0\0\x14\0\0\0\
\x85\0\0\0\x94\0\0\0\x61\xa0\x7c\xfe\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x1b\
\x03\0\0\x63\x01\0\0\0\0\0\0\x18\x60\0\0\0\0\0\0\0\0\0\0\x17\x03\0\0\x18\x61\0\
\0\0\0\0\0\0\0\0\0\x23\x03\0\0\x7b\x01\0\0\0\0\0\0\x18\x60\0\0\0\0\0\0\0\0\0\0\
\x03\x03\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x2b\x03\0\0\x7b\x01\0\0\0\0\0\0\xb7\
\x01\0\0\x02\0\0\0\x18\x62\0\0\0\0\0\0\0\0\0\0\x1b\x03\0\0\xb7\x03\0\0\x20\0\0\
\0\x85\0\0\0\xa6\0\0\0\xbf\x07\0\0\0\0\0\0\xc5\x07\x93\xfe\0\0\0\0\x61\xa0\x7c\
\xfe\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x3b\x03\0\0\x63\x01\0\0\0\0\0\0\xb7\
\x01\0\0\x16\0\0\0\x18\x62\0\0\0\0\0\0\0\0\0\0\x3b\x03\0\0\xb7\x03\0\0\x04\0\0\
\0\x85\0\0\0\xa6\0\0\0\xbf\x07\0\0\0\0\0\0\xc5\x07\x88\xfe\0\0\0\0\x61\xa0\x78\
\xfe\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x6f\x03\0\0\x63\x01\0\0\0\0\0\0\x61\
\x60\x30\0\0\0\0\0\x15\0\x03\0\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x4b\x03\0\0\
\x63\x01\0\0\0\0\0\0\xb7\x01\0\0\0\0\0\0\x18\x62\0\0\0\0\0\0\0\0\0\0\x3f\x03\0\
\0\xb7\x03\0\0\x40\0\0\0\x85\0\0\0\xa6\0\0\0\xbf\x07\0\0\0\0\0\0\xc5\x07\x78\
\xfe\0\0\0\0\x63\x7a\x80\xfe\0\0\0\0\x79\x63\x28\0\0\0\0\0\x15\x03\x04\0\0\0\0\
\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x7f\x03\0\0\xb7\x02\0\0\x08\0\0\0\x85\0\0\0\x94\
\0\0\0\x61\xa0\x80\xfe\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x8b\x03\0\0\x63\x01\
\0\0\0\0\0\0\x18\x60\0\0\0\0\0\0\0\0\0\0\x87\x03\0\0\x18\x61\0\0\0\0\0\0\0\0\0\
\0\x93\x03\0\0\x7b\x01\0\0\0\0\0\0\x18\x60\0\0\0\0\0\0\0\0\0\0\x7f\x03\0\0\x18\
\x61\0\0\0\0\0\0\0\0\0\0\x9b\x03\0\0\x7b\x01\0\0\0\0\0\0\xb7\x01\0\0\x02\0\0\0\
\x18\x62\0\0\0\0\0\0\0\0\0\0\x8b\x03\0\0\xb7\x03\0\0\x20\0\0\0\x85\0\0\0\xa6\0\
\0\0\xbf\x07\0\0\0\0\0\0\xc5\x07\x5c\xfe\0\0\0\0\x18\x60\0\0\0\0\0\0\0\0\0\0\
\xab\x03\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x77\x04\0\0\x7b\x01\0\0\0\0\0\0\x18\
\x60\0\0\0\0\0\0\0\0\0\0\xaf\x03\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x6f\x04\0\0\
\x7b\x01\0\0\0\0\0\0\x18\x60\0\0\0\0\0\0\0\0\0\0\x1f\x04\0\0\x18\x61\0\0\0\0\0\
\0\0\0\0\0\xb7\x04\0\0\x7b\x01\0\0\0\0\0\0\x18\x60\0\0\0\0\0\0\0\0\0\0\x27\x04\
\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\xc7\x04\0\0\x7b\x01\0\0\0\0\0\0\xbf\xa0\0\0\0\
\0\0\0\x07\0\0\0\x7c\xfe\xff\xff\x18\x61\0\0\0\0\0\0\0\0\0\0\xdf\x04\0\0\x7b\
\x01\0\0\0\0\0\0\x61\x60\x08\0\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x7f\x04\0\0\
\x63\x01\0\0\0\0\0\0\x61\x60\x0c\0\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x83\x04\
\0\0\x63\x01\0\0\0\0\0\0\x79\x60\x10\0\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\x87\
\x04\0\0\x7b\x01\0\0\0\0\0\0\x61\xa0\x78\xfe\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\
\0\xaf\x04\0\0\x63\x01\0\0\0\0\0\0\x18\x61\0\0\0\0\0\0\0\0\0\0\xe7\x04\0\0\xb7\
\x02\0\0\x14\0\0\0\xb7\x03\0\0\x0c\0\0\0\xb7\x04\0\0\0\0\0\0\x85\0\0\0\xa7\0\0\
\0\xbf\x07\0\0\0\0\0\0\xc5\x07\x2b\xfe\0\0\0\0\x18\x60\0\0\0\0\0\0\0\0\0\0\x67\
\x04\0\0\x63\x70\x6c\0\0\0\0\0\x77\x07\0\0\x20\0\0\0\x63\x70\x70\0\0\0\0\0\xb7\
\x01\0\0\x05\0\0\0\x18\x62\0\0\0\0\0\0\0\0\0\0\x67\x04\0\0\xb7\x03\0\0\x80\0\0\
\0\x85\0\0\0\xa6\0\0\0\xbf\x07\0\0\0\0\0\0\x18\x60\0\0\0\0\0\0\0\0\0\0\xd7\x04\
\0\0\x61\x01\0\0\0\0\0\0\xd5\x01\x02\0\0\0\0\0\xbf\x19\0\0\0\0\0\0\x85\0\0\0\
\xa8\0\0\0\xc5\x07\x19\xfe\0\0\0\0\x63\x7a\x7c\xff\0\0\0\0\x61\xa1\x78\xfe\0\0\
\0\0\xd5\x01\x02\0\0\0\0\0\xbf\x19\0\0\0\0\0\0\x85\0\0\0\xa8\0\0\0\x61\xa0\x7c\
\xff\0\0\0\0\x63\x06\x38\0\0\0\0\0\x61\xa0\x7c\xfe\0\0\0\0\x63\x06\x18\0\0\0\0\
\0\x61\xa0\x80\xfe\0\0\0\0\x63\x06\x28\0\0\0\0\0\xb7\0\0\0\0\0\0\0\x95\0\0\0\0\
\0\0\0";
	err = bpf_load_and_run(&opts);
	if (err < 0)
		return err;
	skel->rodata =
		mmap(skel->rodata, 65536, PROT_READ, MAP_SHARED | MAP_FIXED,
			skel->maps.rodata.map_fd, 0);
	skel->bss =
		mmap(skel->bss, 65536, PROT_READ | PROT_WRITE, MAP_SHARED | MAP_FIXED,
			skel->maps.bss.map_fd, 0);
	return 0;
}

static inline struct trace_printk *
trace_printk__open_and_load(void)
{
	struct trace_printk *skel;

	skel = trace_printk__open();
	if (!skel)
		return NULL;
	if (trace_printk__load(skel)) {
		trace_printk__destroy(skel);
		return NULL;
	}
	return skel;
}

#endif /* __TRACE_PRINTK_SKEL_H__ */
